import { Redis } from '@upstash/redis';
import { existsSync, mkdirSync, readFileSync, writeFileSync } from 'fs';
import path from 'path';
import { createAnthropic } from '@ai-sdk/anthropic';
import { createOpenAI } from '@ai-sdk/openai';
import { tool, generateText, streamText } from 'ai';
import { z } from 'zod';
import sift from 'sift';
import { setup, assign, fromPromise, createActor } from 'xstate';
import get from 'lodash-es/get';

function asyncGeneratorStep(n, t, e, r, o, a, c) {
  try {
    var i = n[a](c),
      u = i.value;
  } catch (n) {
    return void e(n);
  }
  i.done ? t(u) : Promise.resolve(u).then(r, o);
}
function _asyncToGenerator(n) {
  return function () {
    var t = this,
      e = arguments;
    return new Promise(function (r, o) {
      var a = n.apply(t, e);
      function _next(n) {
        asyncGeneratorStep(a, r, o, _next, _throw, "next", n);
      }
      function _throw(n) {
        asyncGeneratorStep(a, r, o, _next, _throw, "throw", n);
      }
      _next(void 0);
    });
  };
}
function _classPrivateFieldLooseBase(e, t) {
  if (!{}.hasOwnProperty.call(e, t)) throw new TypeError("attempted to use private field on non-instance");
  return e;
}
var id = 0;
function _classPrivateFieldLooseKey(e) {
  return "__private_" + id++ + "_" + e;
}
function _defineProperties(e, r) {
  for (var t = 0; t < r.length; t++) {
    var o = r[t];
    o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o);
  }
}
function _createClass(e, r, t) {
  return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", {
    writable: !1
  }), e;
}
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function (n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _objectWithoutPropertiesLoose(r, e) {
  if (null == r) return {};
  var t = {};
  for (var n in r) if ({}.hasOwnProperty.call(r, n)) {
    if (e.includes(n)) continue;
    t[n] = r[n];
  }
  return t;
}
function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return e;
  };
  var t,
    e = {},
    r = Object.prototype,
    n = r.hasOwnProperty,
    o = Object.defineProperty || function (t, e, r) {
      t[e] = r.value;
    },
    i = "function" == typeof Symbol ? Symbol : {},
    a = i.iterator || "@@iterator",
    c = i.asyncIterator || "@@asyncIterator",
    u = i.toStringTag || "@@toStringTag";
  function define(t, e, r) {
    return Object.defineProperty(t, e, {
      value: r,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), t[e];
  }
  try {
    define({}, "");
  } catch (t) {
    define = function (t, e, r) {
      return t[e] = r;
    };
  }
  function wrap(t, e, r, n) {
    var i = e && e.prototype instanceof Generator ? e : Generator,
      a = Object.create(i.prototype),
      c = new Context(n || []);
    return o(a, "_invoke", {
      value: makeInvokeMethod(t, r, c)
    }), a;
  }
  function tryCatch(t, e, r) {
    try {
      return {
        type: "normal",
        arg: t.call(e, r)
      };
    } catch (t) {
      return {
        type: "throw",
        arg: t
      };
    }
  }
  e.wrap = wrap;
  var h = "suspendedStart",
    l = "suspendedYield",
    f = "executing",
    s = "completed",
    y = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var p = {};
  define(p, a, function () {
    return this;
  });
  var d = Object.getPrototypeOf,
    v = d && d(d(values([])));
  v && v !== r && n.call(v, a) && (p = v);
  var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p);
  function defineIteratorMethods(t) {
    ["next", "throw", "return"].forEach(function (e) {
      define(t, e, function (t) {
        return this._invoke(e, t);
      });
    });
  }
  function AsyncIterator(t, e) {
    function invoke(r, o, i, a) {
      var c = tryCatch(t[r], t, o);
      if ("throw" !== c.type) {
        var u = c.arg,
          h = u.value;
        return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) {
          invoke("next", t, i, a);
        }, function (t) {
          invoke("throw", t, i, a);
        }) : e.resolve(h).then(function (t) {
          u.value = t, i(u);
        }, function (t) {
          return invoke("throw", t, i, a);
        });
      }
      a(c.arg);
    }
    var r;
    o(this, "_invoke", {
      value: function (t, n) {
        function callInvokeWithMethodAndArg() {
          return new e(function (e, r) {
            invoke(t, n, e, r);
          });
        }
        return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(e, r, n) {
    var o = h;
    return function (i, a) {
      if (o === f) throw Error("Generator is already running");
      if (o === s) {
        if ("throw" === i) throw a;
        return {
          value: t,
          done: !0
        };
      }
      for (n.method = i, n.arg = a;;) {
        var c = n.delegate;
        if (c) {
          var u = maybeInvokeDelegate(c, n);
          if (u) {
            if (u === y) continue;
            return u;
          }
        }
        if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) {
          if (o === h) throw o = s, n.arg;
          n.dispatchException(n.arg);
        } else "return" === n.method && n.abrupt("return", n.arg);
        o = f;
        var p = tryCatch(e, r, n);
        if ("normal" === p.type) {
          if (o = n.done ? s : l, p.arg === y) continue;
          return {
            value: p.arg,
            done: n.done
          };
        }
        "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg);
      }
    };
  }
  function maybeInvokeDelegate(e, r) {
    var n = r.method,
      o = e.iterator[n];
    if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y;
    var i = tryCatch(o, e.iterator, r.arg);
    if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y;
    var a = i.arg;
    return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y);
  }
  function pushTryEntry(t) {
    var e = {
      tryLoc: t[0]
    };
    1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e);
  }
  function resetTryEntry(t) {
    var e = t.completion || {};
    e.type = "normal", delete e.arg, t.completion = e;
  }
  function Context(t) {
    this.tryEntries = [{
      tryLoc: "root"
    }], t.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(e) {
    if (e || "" === e) {
      var r = e[a];
      if (r) return r.call(e);
      if ("function" == typeof e.next) return e;
      if (!isNaN(e.length)) {
        var o = -1,
          i = function next() {
            for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next;
            return next.value = t, next.done = !0, next;
          };
        return i.next = i;
      }
    }
    throw new TypeError(typeof e + " is not iterable");
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), o(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) {
    var e = "function" == typeof t && t.constructor;
    return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name));
  }, e.mark = function (t) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t;
  }, e.awrap = function (t) {
    return {
      __await: t
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () {
    return this;
  }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) {
    void 0 === i && (i = Promise);
    var a = new AsyncIterator(wrap(t, r, n, o), i);
    return e.isGeneratorFunction(r) ? a : a.next().then(function (t) {
      return t.done ? t.value : a.next();
    });
  }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () {
    return this;
  }), define(g, "toString", function () {
    return "[object Generator]";
  }), e.keys = function (t) {
    var e = Object(t),
      r = [];
    for (var n in e) r.push(n);
    return r.reverse(), function next() {
      for (; r.length;) {
        var t = r.pop();
        if (t in e) return next.value = t, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, e.values = values, Context.prototype = {
    constructor: Context,
    reset: function (e) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t);
    },
    stop: function () {
      this.done = !0;
      var t = this.tryEntries[0].completion;
      if ("throw" === t.type) throw t.arg;
      return this.rval;
    },
    dispatchException: function (e) {
      if (this.done) throw e;
      var r = this;
      function handle(n, o) {
        return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o;
      }
      for (var o = this.tryEntries.length - 1; o >= 0; --o) {
        var i = this.tryEntries[o],
          a = i.completion;
        if ("root" === i.tryLoc) return handle("end");
        if (i.tryLoc <= this.prev) {
          var c = n.call(i, "catchLoc"),
            u = n.call(i, "finallyLoc");
          if (c && u) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          } else if (c) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
          } else {
            if (!u) throw Error("try statement without catch or finally");
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          }
        }
      }
    },
    abrupt: function (t, e) {
      for (var r = this.tryEntries.length - 1; r >= 0; --r) {
        var o = this.tryEntries[r];
        if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) {
          var i = o;
          break;
        }
      }
      i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null);
      var a = i ? i.completion : {};
      return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a);
    },
    complete: function (t, e) {
      if ("throw" === t.type) throw t.arg;
      return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y;
    },
    finish: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y;
      }
    },
    catch: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.tryLoc === t) {
          var n = r.completion;
          if ("throw" === n.type) {
            var o = n.arg;
            resetTryEntry(r);
          }
          return o;
        }
      }
      throw Error("illegal catch attempt");
    },
    delegateYield: function (e, r, n) {
      return this.delegate = {
        iterator: values(e),
        resultName: r,
        nextLoc: n
      }, "next" === this.method && (this.arg = t), y;
    }
  }, e;
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) {
    return t.__proto__ = e, t;
  }, _setPrototypeOf(t, e);
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}

// Constants and Types
var RegisteredLogger = {
  AGENT: 'AGENT',
  WORKFLOW: 'WORKFLOW'
};
var LogLevel = {
  DEBUG: 'DEBUG',
  INFO: 'INFO',
  WARN: 'WARN',
  ERROR: 'ERROR'
};
// Abstract Base Logger
var BaseLogger = /*#__PURE__*/function () {
  function BaseLogger(level) {
    if (level === void 0) {
      level = LogLevel.INFO;
    }
    this.level = void 0;
    this.level = level;
  }
  var _proto = BaseLogger.prototype;
  _proto.debug = function debug(message) {
    if (this.level <= LogLevel.DEBUG) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      return this.log.apply(this, [LogLevel.DEBUG, message].concat(args));
    }
  };
  _proto.info = function info(message) {
    if (this.level <= LogLevel.INFO) {
      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }
      return this.log.apply(this, [LogLevel.INFO, message].concat(args));
    }
  };
  _proto.warn = function warn(message) {
    if (this.level <= LogLevel.WARN) {
      for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        args[_key3 - 1] = arguments[_key3];
      }
      return this.log.apply(this, [LogLevel.WARN, message].concat(args));
    }
  };
  _proto.error = function error(message) {
    if (this.level <= LogLevel.ERROR) {
      for (var _len4 = arguments.length, args = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
        args[_key4 - 1] = arguments[_key4];
      }
      return this.log.apply(this, [LogLevel.ERROR, message].concat(args));
    }
  };
  _proto.formatMessage = function formatMessage(message) {
    if (typeof message === 'string') {
      return message;
    }
    return JSON.stringify(message);
  };
  _proto.formatLogEntry = function formatLogEntry(level, message) {
    return {
      timestamp: new Date().toISOString(),
      level: LogLevel[level],
      message: this.formatMessage(message)
    };
  };
  return BaseLogger;
}();
// Console Logger Implementation
var ConsoleLogger = /*#__PURE__*/function (_BaseLogger2) {
  function ConsoleLogger(level) {
    return _BaseLogger2.call(this, level != null ? level : LogLevel.INFO) || this;
  }
  _inheritsLoose(ConsoleLogger, _BaseLogger2);
  var _proto2 = ConsoleLogger.prototype;
  _proto2.log = function log(level, message) {
    var _console;
    var logEntry = this.formatLogEntry(level, message);
    for (var _len5 = arguments.length, args = new Array(_len5 > 2 ? _len5 - 2 : 0), _key5 = 2; _key5 < _len5; _key5++) {
      args[_key5 - 2] = arguments[_key5];
    }
    (_console = console).log.apply(_console, ["[" + logEntry.timestamp + "] [" + logEntry.level + "] " + logEntry.message].concat(args));
  };
  return ConsoleLogger;
}(BaseLogger); // File Logger Implementation
var _dirPath = /*#__PURE__*/_classPrivateFieldLooseKey("dirPath");
var FileLogger = /*#__PURE__*/function (_BaseLogger3) {
  function FileLogger(dirPath, level) {
    var _this;
    if (dirPath === void 0) {
      dirPath = 'logs';
    }
    _this = _BaseLogger3.call(this, level != null ? level : LogLevel.INFO) || this;
    Object.defineProperty(_this, _dirPath, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldLooseBase(_this, _dirPath)[_dirPath] = dirPath;
    return _this;
  }
  _inheritsLoose(FileLogger, _BaseLogger3);
  var _proto3 = FileLogger.prototype;
  _proto3.log = function log(level, message) {
    if (typeof message === 'string') {
      throw new Error('FileLogger requires a BaseLogMessage object');
    }
    var fullPath = path.join(_classPrivateFieldLooseBase(this, _dirPath)[_dirPath], message.destinationPath + ".json");
    this.ensureDirectoryExists();
    this.writeLogToFile(fullPath, level, message);
  };
  _proto3.ensureDirectoryExists = function ensureDirectoryExists() {
    if (!existsSync(_classPrivateFieldLooseBase(this, _dirPath)[_dirPath])) {
      mkdirSync(_classPrivateFieldLooseBase(this, _dirPath)[_dirPath], {
        recursive: true
      });
    }
  };
  _proto3.writeLogToFile = function writeLogToFile(fullPath, level, message) {
    var logEntry = _extends({}, message, {
      level: LogLevel[level],
      createdAt: new Date()
    });
    var logs = [];
    if (existsSync(fullPath)) {
      logs = JSON.parse(readFileSync(fullPath, 'utf-8'));
    }
    logs.push(logEntry);
    writeFileSync(fullPath, JSON.stringify(logs, null, 2));
  };
  return FileLogger;
}(BaseLogger); // Upstash Redis Logger Implementation
var _redis = /*#__PURE__*/_classPrivateFieldLooseKey("redis");
var _key6 = /*#__PURE__*/_classPrivateFieldLooseKey("key");
var UpstashRedisLogger = /*#__PURE__*/function (_BaseLogger4) {
  function UpstashRedisLogger(redis, key, level) {
    var _this2;
    if (key === void 0) {
      key = 'logs';
    }
    _this2 = _BaseLogger4.call(this, level != null ? level : LogLevel.INFO) || this;
    Object.defineProperty(_this2, _redis, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this2, _key6, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldLooseBase(_this2, _redis)[_redis] = redis;
    _classPrivateFieldLooseBase(_this2, _key6)[_key6] = key;
    return _this2;
  }
  _inheritsLoose(UpstashRedisLogger, _BaseLogger4);
  var _proto4 = UpstashRedisLogger.prototype;
  _proto4.log = /*#__PURE__*/function () {
    var _log = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(level, message) {
      var logEntry;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (!(typeof message === 'string')) {
              _context.next = 2;
              break;
            }
            throw new Error('UpstashRedisLogger requires a BaseLogMessage object');
          case 2:
            logEntry = _extends({}, message, {
              level: LogLevel[level],
              createdAt: new Date()
            });
            _context.next = 5;
            return _classPrivateFieldLooseBase(this, _redis)[_redis].lpush(_classPrivateFieldLooseBase(this, _key6)[_key6], JSON.stringify(logEntry));
          case 5:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function log(_x, _x2) {
      return _log.apply(this, arguments);
    }
    return log;
  }();
  _proto4.getLogs = /*#__PURE__*/function () {
    var _getLogs = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt("return", _classPrivateFieldLooseBase(this, _redis)[_redis].lrange(_classPrivateFieldLooseBase(this, _key6)[_key6], 0, -1));
          case 1:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function getLogs() {
      return _getLogs.apply(this, arguments);
    }
    return getLogs;
  }();
  _proto4.cleanup = /*#__PURE__*/function () {
    var _cleanup = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
          case "end":
            return _context3.stop();
        }
      }, _callee3);
    }));
    function cleanup() {
      return _cleanup.apply(this, arguments);
    }
    return cleanup;
  }();
  return UpstashRedisLogger;
}(BaseLogger); // Multi Logger Implementation
var MultiLogger = /*#__PURE__*/function () {
  function MultiLogger(loggers) {
    this.loggers = void 0;
    this.loggers = loggers;
  }
  var _proto5 = MultiLogger.prototype;
  _proto5.debug = /*#__PURE__*/function () {
    var _debug = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee4(message) {
      var _len6,
        args,
        _key7,
        _args4 = arguments;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            for (_len6 = _args4.length, args = new Array(_len6 > 1 ? _len6 - 1 : 0), _key7 = 1; _key7 < _len6; _key7++) {
              args[_key7 - 1] = _args4[_key7];
            }
            _context4.next = 3;
            return Promise.all(this.loggers.map(function (logger) {
              return logger.debug.apply(logger, [message].concat(args));
            }));
          case 3:
          case "end":
            return _context4.stop();
        }
      }, _callee4, this);
    }));
    function debug(_x3) {
      return _debug.apply(this, arguments);
    }
    return debug;
  }();
  _proto5.info = /*#__PURE__*/function () {
    var _info = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee5(message) {
      var _len7,
        args,
        _key8,
        _args5 = arguments;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            for (_len7 = _args5.length, args = new Array(_len7 > 1 ? _len7 - 1 : 0), _key8 = 1; _key8 < _len7; _key8++) {
              args[_key8 - 1] = _args5[_key8];
            }
            _context5.next = 3;
            return Promise.all(this.loggers.map(function (logger) {
              return logger.info.apply(logger, [message].concat(args));
            }));
          case 3:
          case "end":
            return _context5.stop();
        }
      }, _callee5, this);
    }));
    function info(_x4) {
      return _info.apply(this, arguments);
    }
    return info;
  }();
  _proto5.warn = /*#__PURE__*/function () {
    var _warn = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee6(message) {
      var _len8,
        args,
        _key9,
        _args6 = arguments;
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            for (_len8 = _args6.length, args = new Array(_len8 > 1 ? _len8 - 1 : 0), _key9 = 1; _key9 < _len8; _key9++) {
              args[_key9 - 1] = _args6[_key9];
            }
            _context6.next = 3;
            return Promise.all(this.loggers.map(function (logger) {
              return logger.warn.apply(logger, [message].concat(args));
            }));
          case 3:
          case "end":
            return _context6.stop();
        }
      }, _callee6, this);
    }));
    function warn(_x5) {
      return _warn.apply(this, arguments);
    }
    return warn;
  }();
  _proto5.error = /*#__PURE__*/function () {
    var _error = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee7(message) {
      var _len9,
        args,
        _key10,
        _args7 = arguments;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) switch (_context7.prev = _context7.next) {
          case 0:
            for (_len9 = _args7.length, args = new Array(_len9 > 1 ? _len9 - 1 : 0), _key10 = 1; _key10 < _len9; _key10++) {
              args[_key10 - 1] = _args7[_key10];
            }
            _context7.next = 3;
            return Promise.all(this.loggers.map(function (logger) {
              return logger.error.apply(logger, [message].concat(args));
            }));
          case 3:
          case "end":
            return _context7.stop();
        }
      }, _callee7, this);
    }));
    function error(_x6) {
      return _error.apply(this, arguments);
    }
    return error;
  }();
  _proto5.cleanup = /*#__PURE__*/function () {
    var _cleanup2 = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee9() {
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) switch (_context9.prev = _context9.next) {
          case 0:
            _context9.next = 2;
            return Promise.all(this.loggers.map(/*#__PURE__*/function () {
              var _ref = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee8(logger) {
                return _regeneratorRuntime().wrap(function _callee8$(_context8) {
                  while (1) switch (_context8.prev = _context8.next) {
                    case 0:
                      if (!logger.cleanup) {
                        _context8.next = 3;
                        break;
                      }
                      _context8.next = 3;
                      return logger.cleanup();
                    case 3:
                    case "end":
                      return _context8.stop();
                  }
                }, _callee8);
              }));
              return function (_x7) {
                return _ref.apply(this, arguments);
              };
            }()));
          case 2:
          case "end":
            return _context9.stop();
        }
      }, _callee9, this);
    }));
    function cleanup() {
      return _cleanup2.apply(this, arguments);
    }
    return cleanup;
  }();
  return MultiLogger;
}();
// Factory function for built-in loggers
// In createLogger function
function createLogger(config) {
  switch (config.type) {
    case 'CONSOLE':
      return new ConsoleLogger(config.level);
    case 'FILE':
      return new FileLogger(config.dirPath, config.level);
    case 'UPSTASH':
      var redis = new Redis({
        url: config.url,
        token: config.token
      });
      return new UpstashRedisLogger(redis, config.key, config.level);
    default:
      throw new Error("Unsupported logger type");
  }
}
function createMultiLogger(loggers) {
  return new MultiLogger(loggers);
}

var delay = function delay(ms) {
  return new Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
};

var _tools = /*#__PURE__*/_classPrivateFieldLooseKey("tools");
var LLM = /*#__PURE__*/function () {
  function LLM(logger) {
    Object.defineProperty(this, _tools, {
      writable: true,
      value: void 0
    });
    this.logger = void 0;
    _classPrivateFieldLooseBase(this, _tools)[_tools] = {};
    this.logger = logger || createLogger({
      type: 'CONSOLE'
    });
  }
  /**
   * Set the concrete tools for the agent
   * @param tools
   */
  var _proto = LLM.prototype;
  _proto.__setTools = function __setTools(tools) {
    _classPrivateFieldLooseBase(this, _tools)[_tools] = tools;
    this.logger.debug("Tools set for LLM", tools);
  };
  _proto.getModelType = function getModelType(model) {
    var providerToType = {
      OPEN_AI_VERCEL: 'openai',
      ANTHROPIC_VERCEL: 'anthropic',
      GROQ_VERCEL: 'groq',
      PERPLEXITY_VERCEL: 'perplexity',
      FIREWORKS_VERCEL: 'fireworks'
    };
    var type = providerToType[model.provider] || 'openai';
    this.logger.debug("Model type resolved to " + type + " for provider " + model.provider);
    return type;
  };
  _proto.createOpenAICompatibleModel = function createOpenAICompatibleModel(baseURL, apiKey, defaultModelName, modelName) {
    this.logger.debug("Creating OpenAI compatible model with baseURL: " + baseURL);
    var client = createOpenAI({
      baseURL: baseURL,
      apiKey: apiKey
    });
    return client(modelName || defaultModelName);
  };
  _proto.createModelDef = function createModelDef(_ref) {
    var model = _ref.model;
    var modelDef;
    if (model.type === 'openai') {
      this.logger.info("Initializing OpenAI model " + (model.name || 'gpt-4o-2024-08-06'));
      var openai = createOpenAI({
        apiKey: process.env.OPENAI_API_KEY
      });
      modelDef = openai(model.name || 'gpt-4o-2024-08-06', {
        structuredOutputs: true
      });
    } else if (model.type === 'anthropic') {
      this.logger.info("Initializing Anthropic model " + (model.name || 'claude-3-5-sonnet-20240620'));
      var anthropic = createAnthropic({
        apiKey: process.env.ANTHROPIC_API_KEY
      });
      modelDef = anthropic(model.name || 'claude-3-5-sonnet-20240620');
    } else if (model.type === 'groq') {
      var _process$env$GROQ_API;
      this.logger.info("Initializing Groq model " + (model.name || 'llama-3.2-90b-text-preview'));
      modelDef = this.createOpenAICompatibleModel('https://api.groq.com/openai/v1', (_process$env$GROQ_API = process.env.GROQ_API_KEY) != null ? _process$env$GROQ_API : '', 'llama-3.2-90b-text-preview', model.name);
    } else if (model.type === 'perplexity') {
      var _process$env$PERPLEXI;
      this.logger.info("Initializing Perplexity model " + (model.name || 'llama-3.1-sonar-large-128k-chat'));
      modelDef = this.createOpenAICompatibleModel('https://api.perplexity.ai/', (_process$env$PERPLEXI = process.env.PERPLEXITY_API_KEY) != null ? _process$env$PERPLEXI : '', 'llama-3.1-sonar-large-128k-chat', model.name);
    } else if (model.type === 'fireworks') {
      var _process$env$FIREWORK;
      this.logger.info("Initializing Fireworks model " + (model.name || 'llama-v3p1-70b-instruct'));
      modelDef = this.createOpenAICompatibleModel('https://api.fireworks.ai/inference/v1', (_process$env$FIREWORK = process.env.FIREWORKS_API_KEY) != null ? _process$env$FIREWORK : '', 'llama-v3p1-70b-instruct', model.name);
    } else {
      var error = "Invalid model type: " + model.type;
      this.logger.error(error);
      throw new Error(error);
    }
    return modelDef;
  };
  _proto.getParams = function getParams(_ref2) {
    var tools = _ref2.tools,
      resultTool = _ref2.resultTool,
      model = _ref2.model;
    var toolsConverted = Object.entries(tools).reduce(function (memo, _ref3) {
      var key = _ref3[0],
        val = _ref3[1];
      memo[key] = tool(val);
      return memo;
    }, {});
    var answerTool = {};
    if (resultTool) {
      answerTool = {
        answer: tool(resultTool)
      };
    }
    var modelDef = this.createModelDef({
      model: model
    });
    return {
      toolsConverted: toolsConverted,
      modelDef: modelDef,
      answerTool: answerTool,
      toolChoice: model.toolChoice || 'required'
    };
  };
  _proto.convertTools = function convertTools(enabledTools) {
    var _this = this;
    var converted = Object.entries(enabledTools || {}).reduce(function (memo, value) {
      var k = value[0];
      var enabled = value[1];
      var tool = _classPrivateFieldLooseBase(_this, _tools)[_tools][k];
      if (enabled && tool) {
        memo[k] = {
          description: tool.description,
          parameters: z.object({
            data: tool.schema
          }),
          execute: tool.executor
        };
      }
      return memo;
    }, {});
    this.logger.debug("Converted tools for LLM", converted);
    return converted;
  };
  _proto.text = /*#__PURE__*/function () {
    var _text = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref4) {
      var _this2 = this;
      var model, messages, _onStepFinish, _ref4$maxSteps, maxSteps, enabledTools, params, argsForExecute;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            model = _ref4.model, messages = _ref4.messages, _onStepFinish = _ref4.onStepFinish, _ref4$maxSteps = _ref4.maxSteps, maxSteps = _ref4$maxSteps === void 0 ? 5 : _ref4$maxSteps, enabledTools = _ref4.enabledTools;
            params = this.getParams({
              tools: this.convertTools(enabledTools || {}),
              model: {
                type: this.getModelType(model),
                name: model.name,
                toolChoice: model.toolChoice
              }
            });
            argsForExecute = {
              model: params.modelDef,
              tools: _extends({}, params.toolsConverted, params.answerTool),
              toolChoice: params.toolChoice,
              maxSteps: maxSteps,
              onStepFinish: function () {
                var _onStepFinish2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(props) {
                  var _props$response, _props$response2;
                  return _regeneratorRuntime().wrap(function _callee$(_context) {
                    while (1) switch (_context.prev = _context.next) {
                      case 0:
                        _onStepFinish == null || _onStepFinish(JSON.stringify(props, null, 2));
                        if (!(props != null && (_props$response = props.response) != null && (_props$response = _props$response.headers) != null && _props$response['x-ratelimit-remaining-tokens'] && parseInt(props == null || (_props$response2 = props.response) == null || (_props$response2 = _props$response2.headers) == null ? void 0 : _props$response2['x-ratelimit-remaining-tokens'], 10) < 2000)) {
                          _context.next = 5;
                          break;
                        }
                        _this2.logger.warn('Rate limit approaching, waiting 10 seconds');
                        _context.next = 5;
                        return delay(10 * 1000);
                      case 5:
                      case "end":
                        return _context.stop();
                    }
                  }, _callee);
                }));
                function onStepFinish(_x2) {
                  return _onStepFinish2.apply(this, arguments);
                }
                return onStepFinish;
              }()
            };
            this.logger.debug("Generating text with " + messages.length + " messages");
            _context2.next = 6;
            return generateText(_extends({
              messages: messages
            }, argsForExecute));
          case 6:
            return _context2.abrupt("return", _context2.sent);
          case 7:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function text(_x) {
      return _text.apply(this, arguments);
    }
    return text;
  }();
  _proto.stream = /*#__PURE__*/function () {
    var _stream = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee5(_ref5) {
      var _this3 = this;
      var model, messages, _onStepFinish3, _onFinish, _ref5$maxSteps, maxSteps, enabledTools, params, argsForExecute;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            model = _ref5.model, messages = _ref5.messages, _onStepFinish3 = _ref5.onStepFinish, _onFinish = _ref5.onFinish, _ref5$maxSteps = _ref5.maxSteps, maxSteps = _ref5$maxSteps === void 0 ? 5 : _ref5$maxSteps, enabledTools = _ref5.enabledTools;
            params = this.getParams({
              tools: this.convertTools(enabledTools),
              model: {
                type: this.getModelType(model),
                name: model.name,
                toolChoice: model.toolChoice
              }
            });
            argsForExecute = {
              model: params.modelDef,
              tools: _extends({}, params.toolsConverted, params.answerTool),
              toolChoice: params.toolChoice,
              maxSteps: maxSteps,
              onStepFinish: function () {
                var _onStepFinish4 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3(props) {
                  var _props$response3, _props$response4;
                  return _regeneratorRuntime().wrap(function _callee3$(_context3) {
                    while (1) switch (_context3.prev = _context3.next) {
                      case 0:
                        _onStepFinish3 == null || _onStepFinish3(JSON.stringify(props, null, 2));
                        if (!(props != null && (_props$response3 = props.response) != null && (_props$response3 = _props$response3.headers) != null && _props$response3['x-ratelimit-remaining-tokens'] && parseInt(props == null || (_props$response4 = props.response) == null || (_props$response4 = _props$response4.headers) == null ? void 0 : _props$response4['x-ratelimit-remaining-tokens'], 10) < 2000)) {
                          _context3.next = 5;
                          break;
                        }
                        _this3.logger.warn('Rate limit approaching, waiting 10 seconds');
                        _context3.next = 5;
                        return delay(10 * 1000);
                      case 5:
                      case "end":
                        return _context3.stop();
                    }
                  }, _callee3);
                }));
                function onStepFinish(_x4) {
                  return _onStepFinish4.apply(this, arguments);
                }
                return onStepFinish;
              }(),
              onFinish: function () {
                var _onFinish2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee4(props) {
                  return _regeneratorRuntime().wrap(function _callee4$(_context4) {
                    while (1) switch (_context4.prev = _context4.next) {
                      case 0:
                        _onFinish == null || _onFinish(JSON.stringify(props, null, 2));
                      case 1:
                      case "end":
                        return _context4.stop();
                    }
                  }, _callee4);
                }));
                function onFinish(_x5) {
                  return _onFinish2.apply(this, arguments);
                }
                return onFinish;
              }()
            };
            this.logger.debug("Streaming text with " + messages.length + " messages");
            _context5.next = 6;
            return streamText(_extends({
              messages: messages
            }, argsForExecute));
          case 6:
            return _context5.abrupt("return", _context5.sent);
          case 7:
          case "end":
            return _context5.stop();
        }
      }, _callee5, this);
    }));
    function stream(_x3) {
      return _stream.apply(this, arguments);
    }
    return stream;
  }();
  return LLM;
}();

var Agent = /*#__PURE__*/function () {
  function Agent(config) {
    this.name = void 0;
    this.llm = void 0;
    this.instructions = void 0;
    this.model = void 0;
    this.enabledTools = void 0;
    this.logger = void 0;
    this.name = config.name;
    this.instructions = config.instructions;
    this.llm = new LLM();
    this.model = config.model;
    this.enabledTools = config.enabledTools || {};
    this.logger = createLogger({
      type: 'CONSOLE'
    });
    this.logger.info("Agent " + this.name + " initialized with model " + this.model.provider);
  }
  /**
   * Set the concrete tools for the agent
   * @param tools
   */
  var _proto = Agent.prototype;
  _proto.__setTools = function __setTools(tools) {
    this.llm.__setTools(tools);
    this.logger.debug("Tools set for agent " + this.name, tools);
  }
  /**
   * Set the logger for the agent
   * @param logger
   */;
  _proto.__setLogger = function __setLogger(logger) {
    this.logger = logger;
    this.logger.debug("Logger updated for agent " + this.name);
  };
  _proto.text = /*#__PURE__*/function () {
    var _text = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref) {
      var messages, onStepFinish, _ref$maxSteps, maxSteps, messageObjects;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            messages = _ref.messages, onStepFinish = _ref.onStepFinish, _ref$maxSteps = _ref.maxSteps, maxSteps = _ref$maxSteps === void 0 ? 5 : _ref$maxSteps;
            this.logger.info("Starting text generation for agent " + this.name);
            messageObjects = messages.map(function (content) {
              return {
                role: 'user',
                content: content
              };
            });
            messageObjects.push({
              role: 'system',
              content: this.instructions
            });
            return _context.abrupt("return", this.llm.text({
              model: this.model,
              messages: messageObjects,
              enabledTools: this.enabledTools,
              onStepFinish: onStepFinish,
              maxSteps: maxSteps
            }));
          case 5:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function text(_x) {
      return _text.apply(this, arguments);
    }
    return text;
  }();
  _proto.stream = /*#__PURE__*/function () {
    var _stream = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref2) {
      var messages, onStepFinish, onFinish, _ref2$maxSteps, maxSteps, messageObjects;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            messages = _ref2.messages, onStepFinish = _ref2.onStepFinish, onFinish = _ref2.onFinish, _ref2$maxSteps = _ref2.maxSteps, maxSteps = _ref2$maxSteps === void 0 ? 5 : _ref2$maxSteps;
            this.logger.info("Starting stream generation for agent " + this.name);
            messageObjects = messages.map(function (content) {
              return {
                role: 'user',
                content: content
              };
            });
            messageObjects.push({
              role: 'system',
              content: this.instructions
            });
            return _context2.abrupt("return", this.llm.stream({
              messages: messageObjects,
              model: this.model,
              enabledTools: this.enabledTools,
              onStepFinish: onStepFinish,
              onFinish: onFinish,
              maxSteps: maxSteps
            }));
          case 5:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function stream(_x2) {
      return _stream.apply(this, arguments);
    }
    return stream;
  }();
  return Agent;
}();

// TODO: Passing the In/out generics works but seems to break on plugin to mastra, fix.
function createTool(opts) {
  return opts;
}

var _excluded = ["client"];
var Integration = /*#__PURE__*/function () {
  function Integration() {
    this.authType = 'API_KEY';
  }
  var _proto = Integration.prototype;
  _proto.getApiClient = /*#__PURE__*/function () {
    var _getApiClient = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            throw new Error('API not implemented');
          case 1:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    function getApiClient() {
      return _getApiClient.apply(this, arguments);
    }
    return getApiClient;
  }();
  _proto._generateIntegrationTools = function _generateIntegrationTools() {
    var _this = this;
    var _this$baseClient = this.baseClient,
      clientMethods = _objectWithoutPropertiesLoose(_this$baseClient, _excluded);
    var schemas = this.toolSchemas;
    var documentations = this.toolDocumentations;
    var tools = Object.keys(clientMethods).reduce(function (acc, key) {
      var _documentations$key, _documentations$key2, _extends2;
      var comment = (_documentations$key = documentations[key]) == null ? void 0 : _documentations$key.comment;
      var doc = (_documentations$key2 = documentations[key]) == null ? void 0 : _documentations$key2.doc;
      var fallbackComment = "Execute " + key;
      var tool = createTool({
        label: key,
        schema: schemas[key] || z.object({}),
        description: comment || fallbackComment,
        documentation: doc || fallbackComment,
        executor: function () {
          var _executor = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref) {
            var data, client, value;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  data = _ref.data;
                  _context2.next = 3;
                  return _this.getApiClient();
                case 3:
                  client = _context2.sent;
                  value = client[key];
                  return _context2.abrupt("return", value(_extends({}, data)));
                case 6:
                case "end":
                  return _context2.stop();
              }
            }, _callee2);
          }));
          function executor(_x) {
            return _executor.apply(this, arguments);
          }
          return executor;
        }()
      });
      return _extends({}, acc, (_extends2 = {}, _extends2[key] = tool, _extends2));
    }, {});
    return tools;
  };
  return _createClass(Integration, [{
    key: "toolSchemas",
    get: function get() {
      return {};
    }
  }, {
    key: "toolDocumentations",
    get: function get() {
      return {};
    }
  }, {
    key: "baseClient",
    get: function get() {
      return {};
    }
  }]);
}();

var PropertyType;
(function (PropertyType) {
  PropertyType["LONG_TEXT"] = "LONG_TEXT";
  PropertyType["SINGLE_LINE_TEXT"] = "SINGLE_LINE_TEXT";
  PropertyType["SINGLE_SELECT"] = "SINGLE_SELECT";
  PropertyType["MULTI_SELECT"] = "MULTI_SELECT";
  PropertyType["CHECKBOX"] = "CHECKBOX";
  PropertyType["DATE"] = "DATE";
  PropertyType["USER"] = "USER";
  PropertyType["BADGE_LIST"] = "BADGE_LIST";
  PropertyType["CURRENCY"] = "CURRENCY";
  PropertyType["URL"] = "URL";
  PropertyType["PHONE"] = "PHONE";
  PropertyType["CONTACT"] = "CONTACT";
  PropertyType["COMPANY"] = "COMPANY";
  PropertyType["PERSON"] = "PERSON";
  PropertyType["ENRICHMENT"] = "ENRICHMENT";
  PropertyType["COMPOSITE"] = "COMPOSITE";
  PropertyType["BOOLEAN"] = "BOOLEAN";
  PropertyType["NUMBER"] = "NUMBER";
  PropertyType["FLOAT"] = "FLOAT";
  PropertyType["JSON_OBJECT"] = "JSON_OBJECT";
  PropertyType["JSON_ARRAY"] = "JSON_ARRAY";
})(PropertyType || (PropertyType = {}));
var FilterOperators;
(function (FilterOperators) {
  FilterOperators["IS"] = "is";
  FilterOperators["EQUAL"] = "eq";
  FilterOperators["NOT_EQUAL"] = "not_eq";
  FilterOperators["CONTAINS"] = "contains";
  FilterOperators["IN"] = "in";
  FilterOperators["NOT_IN"] = "not_in";
  FilterOperators["GREATER_THAN"] = "gt";
  FilterOperators["LESS_THAN"] = "lt";
  FilterOperators["NOT_CONTAINS"] = "not_contains";
  FilterOperators["GREATER_THAN_OR_EQUAL"] = "gte";
  FilterOperators["LESS_THAN_OR_EQUAL"] = "lte";
  FilterOperators["OP"] = "op";
  FilterOperators["SET"] = "set";
  FilterOperators["NOT_SET"] = "not_set";
})(FilterOperators || (FilterOperators = {}));

var _FieldTypePrimitiveMa;
var FieldTypePrimitiveMap = (_FieldTypePrimitiveMa = {}, _FieldTypePrimitiveMa[PropertyType.BADGE_LIST] = 'string', _FieldTypePrimitiveMa[PropertyType.CHECKBOX] = 'boolean', _FieldTypePrimitiveMa[PropertyType.BOOLEAN] = 'boolean', _FieldTypePrimitiveMa[PropertyType.NUMBER] = 'number', _FieldTypePrimitiveMa[PropertyType.FLOAT] = 'number', _FieldTypePrimitiveMa[PropertyType.JSON_ARRAY] = 'string', _FieldTypePrimitiveMa[PropertyType.JSON_OBJECT] = 'string', _FieldTypePrimitiveMa[PropertyType.CURRENCY] = 'number', _FieldTypePrimitiveMa[PropertyType.DATE] = 'date', _FieldTypePrimitiveMa[PropertyType.LONG_TEXT] = 'string', _FieldTypePrimitiveMa[PropertyType.MULTI_SELECT] = 'string', _FieldTypePrimitiveMa[PropertyType.PHONE] = 'string', _FieldTypePrimitiveMa[PropertyType.SINGLE_LINE_TEXT] = 'string', _FieldTypePrimitiveMa[PropertyType.SINGLE_SELECT] = 'string', _FieldTypePrimitiveMa[PropertyType.URL] = 'string', _FieldTypePrimitiveMa[PropertyType.USER] = 'string', _FieldTypePrimitiveMa[PropertyType.CONTACT] = 'string', _FieldTypePrimitiveMa[PropertyType.COMPANY] = 'string', _FieldTypePrimitiveMa[PropertyType.COMPOSITE] = 'string', _FieldTypePrimitiveMa[PropertyType.PERSON] = 'string', _FieldTypePrimitiveMa[PropertyType.ENRICHMENT] = 'string', _FieldTypePrimitiveMa);
/**
 * Split a string on commas and strip quotes from each part
 * @param str input string
 * @returns array of strings
 */
var splitAndStripQuotes = function splitAndStripQuotes(str) {
  // Raw regex pattern for splitting on non-quoted commas
  var pattern = /,\s*(?=(?:[^"]*"[^"]*")*[^"]*$)/;
  // Split the string
  var parts = str.split(pattern);
  // Strip quotes from each part
  var cleanedParts = parts.map(function (part) {
    return part.trim().replace(/^"|"$/g, '');
  });
  return cleanedParts;
};
var transformFilterValueArray = function transformFilterValueArray(value) {
  if (typeof value === 'string') return value.split(',');
  return value;
};
var transformFilterValueBoolean = function transformFilterValueBoolean(value) {
  if (typeof value === 'string') return value === 'true';
  return value;
};
/**
 * This returns the SQL field for a JSON field with appropriate casting.
 * @param column - JSON field to cast.
 * @param type - Type of the JSON field.
 */
var getJSONField = function getJSONField(column, type) {
  var primitiveType = FieldTypePrimitiveMap[type];
  switch (primitiveType) {
    case 'number':
      {
        // cast to number if field is numeric
        return "(" + column + ")::bigint";
      }
    case 'boolean':
      {
        // cast to boolean if field is boolean
        return "(" + column + ")::boolean";
      }
    case 'date':
      {
        return "(" + column + ")::timestamp";
      }
  }
  return "(" + column + ")::text";
};
/**
 * @description
 * Builds a query string from filter and sort query strings
 * @param filterQueryString Filter query string
 * @param sortQueryString Sort query string
 * @returns
 */
function buildQueryString(_ref) {
  var filterQueryString = _ref.filterQueryString,
    sortQueryString = _ref.sortQueryString;
  if (!filterQueryString && !sortQueryString) return '';
  if (!filterQueryString) return "" + sortQueryString;
  if (!sortQueryString) return "" + filterQueryString;
  return filterQueryString + "&" + sortQueryString;
}

var filterQuerySchema = /*#__PURE__*/z.object({
  is: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  eq: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  not_eq: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  contains: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  not_contains: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  gt: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  gte: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  lt: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  lte: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  "in": /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  not_in: /*#__PURE__*/z.array(z.string()).or(z.string()).optional(),
  op: /*#__PURE__*/z["enum"](['or', 'and']).optional()["default"]('or'),
  set: /*#__PURE__*/z.string().optional().transform(transformFilterValueBoolean),
  not_set: /*#__PURE__*/z.string().optional().transform(transformFilterValueBoolean)
});
var sortQuerySchema = /*#__PURE__*/z.string().transform(transformFilterValueArray);

var MastraEngine =
/**
 * Initializes the database connection
 * @param config Configuration object for database connection
 */
function MastraEngine(config) {};

var MastraVector = function MastraVector() {};

var Mastra = /*#__PURE__*/function () {
  function Mastra(config) {
    var _config$integrations,
      _this = this,
      _config$integrations2,
      _config$agents,
      _config$workflows;
    this.engine = void 0;
    this.vectors = void 0;
    this.tools = void 0;
    this.agents = void 0;
    this.llm = void 0;
    this.integrations = void 0;
    this.logger = void 0;
    this.syncs = void 0;
    this.workflows = new Map();
    this.logger = new Map();
    var logger = createLogger({
      type: 'CONSOLE'
    });
    if (config.logger) {
      logger = config.logger;
    }
    this.setLogger({
      key: 'AGENT',
      logger: logger
    });
    this.setLogger({
      key: 'WORKFLOW',
      logger: logger
    });
    this.integrations = new Map();
    (_config$integrations = config.integrations) == null || _config$integrations.forEach(function (integration) {
      if (_this.integrations.has(integration.name)) {
        throw new Error("Integration with name " + integration.name + " already exists");
      }
      _this.integrations.set(integration.name, integration);
    });
    var integrationTools = ((_config$integrations2 = config.integrations) == null ? void 0 : _config$integrations2.reduce(function (acc, integration) {
      return _extends({}, acc, integration.tools);
    }, {})) || {};
    var configuredTools = (config == null ? void 0 : config.tools) || {};
    // Merge custom tools with integration tools
    var allTools = _extends({}, configuredTools, integrationTools);
    // Hydrate tools with integration tools
    var hydratedTools = Object.entries(allTools != null ? allTools : {}).reduce(function (memo, _ref) {
      var key = _ref[0],
        val = _ref[1];
      memo[key] = _extends({}, val, {
        executor: function executor(params) {
          return val.executor(_extends({}, params, {
            getIntegration: function getIntegration(name) {
              return _this.getIntegration(name);
            },
            agents: _this.agents,
            llm: _this.llm,
            engine: _this.engine
          }));
        }
      });
      return memo;
    }, {});
    this.tools = hydratedTools;
    this.agents = new Map();
    this.llm = new LLM();
    this.llm.__setTools(this.tools);
    (_config$agents = config.agents) == null || _config$agents.forEach(function (agent) {
      if (_this.agents.has(agent.name)) {
        throw new Error("Agent with name " + agent.name + " already exists");
      }
      _this.agents.set(agent.name, agent);
      agent.__setTools(_this.tools);
      var agentLogger = _this.getLogger('AGENT');
      if (agentLogger) {
        agent.__setLogger(agentLogger);
      }
    });
    (_config$workflows = config.workflows) == null || _config$workflows.forEach(function (workflow) {
      if (_this.workflows.has(workflow.name)) {
        throw new Error("Workflow with name " + workflow.name + " already exists");
      }
      _this.workflows.set(workflow.name, workflow);
    });
    if (config.syncs && !config.engine) {
      throw new Error('Engine is required to run syncs');
    }
    this.syncs = config.syncs || {};
    if (config.engine) {
      this.engine = config.engine;
    }
    if (config.vectors) {
      this.vectors = config.vectors;
    }
  }
  var _proto = Mastra.prototype;
  _proto.sync = /*#__PURE__*/function () {
    var _sync = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(key, params) {
      var _this$syncs;
      var syncFn;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (this.engine) {
              _context.next = 2;
              break;
            }
            throw new Error("Sync function " + key + " not found");
          case 2:
            syncFn = (_this$syncs = this.syncs) == null ? void 0 : _this$syncs[key];
            if (syncFn) {
              _context.next = 5;
              break;
            }
            throw new Error("Sync function " + key + " not found");
          case 5:
            _context.next = 7;
            return syncFn({
              tools: this.tools,
              params: params,
              engine: this.engine,
              agents: this.agents,
              vectors: this.vectors,
              llm: this.llm
            });
          case 7:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function sync(_x, _x2) {
      return _sync.apply(this, arguments);
    }
    return sync;
  }();
  _proto.getAgent = function getAgent(name) {
    var agent = this.agents.get(name);
    if (!agent) {
      throw new Error("Agent with name " + name + " not found");
    }
    return agent;
  };
  _proto.getIntegration = function getIntegration(name) {
    var stringifiedName = String(name);
    var integration = this.integrations.get(stringifiedName.toUpperCase());
    if (!integration) {
      throw new Error("Integration with name " + stringifiedName + " not found");
    }
    return integration;
  };
  _proto.getTool = function getTool(name) {
    var _this2 = this;
    var tool = this.tools[name];
    if (!tool) {
      throw new Error("Tool with name " + String(name) + " not found");
    }
    return _extends({}, tool, {
      execute: function () {
        var _execute = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(params) {
          return _regeneratorRuntime().wrap(function _callee2$(_context2) {
            while (1) switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", tool.executor({
                  data: params,
                  getIntegration: function getIntegration(name) {
                    return _this2.getIntegration(name);
                  },
                  agents: _this2.agents,
                  llm: _this2.llm,
                  engine: _this2.engine
                }));
              case 1:
              case "end":
                return _context2.stop();
            }
          }, _callee2);
        }));
        function execute(_x3) {
          return _execute.apply(this, arguments);
        }
        return execute;
      }()
    });
  };
  _proto.availableIntegrations = function availableIntegrations() {
    return Array.from(this.integrations.entries()).map(function (_ref2) {
      var name = _ref2[0],
        integration = _ref2[1];
      return {
        name: name,
        integration: integration
      };
    });
  };
  _proto.getTools = function getTools() {
    return this.tools;
  };
  _proto.setLogger = function setLogger(_ref3) {
    var key = _ref3.key,
      logger = _ref3.logger;
    this.logger.set(key, logger);
  };
  _proto.getLogger = function getLogger(key) {
    return this.logger.get(key);
  };
  return Mastra;
}();

function isErrorEvent(stateEvent) {
  return stateEvent.type.startsWith('xstate.error.actor.');
}
function isTransitionEvent(stateEvent) {
  return stateEvent.type.startsWith('xstate.done.actor.');
}

var _logger = /*#__PURE__*/_classPrivateFieldLooseKey("logger");
var _steps = /*#__PURE__*/_classPrivateFieldLooseKey("steps");
var _machine = /*#__PURE__*/_classPrivateFieldLooseKey("machine");
var _actor = /*#__PURE__*/_classPrivateFieldLooseKey("actor");
var _log = /*#__PURE__*/_classPrivateFieldLooseKey("log");
var _buildStateHierarchy = /*#__PURE__*/_classPrivateFieldLooseKey("buildStateHierarchy");
var _isVariableReference = /*#__PURE__*/_classPrivateFieldLooseKey("isVariableReference");
var _createStepId = /*#__PURE__*/_classPrivateFieldLooseKey("createStepId");
var _resolveVariables = /*#__PURE__*/_classPrivateFieldLooseKey("resolveVariables");
var _cleanup = /*#__PURE__*/_classPrivateFieldLooseKey("cleanup");
var _evaluateCondition = /*#__PURE__*/_classPrivateFieldLooseKey("evaluateCondition");
var _validateWorkflow = /*#__PURE__*/_classPrivateFieldLooseKey("validateWorkflow");
var _detectCircularDependencies = /*#__PURE__*/_classPrivateFieldLooseKey("detectCircularDependencies");
var _validateTerminalPaths = /*#__PURE__*/_classPrivateFieldLooseKey("validateTerminalPaths");
var _detectUnreachableSteps = /*#__PURE__*/_classPrivateFieldLooseKey("detectUnreachableSteps");
var Workflow = /*#__PURE__*/function () {
  /**
   * Creates a new Workflow instance
   * @param name - Identifier for the workflow (not necessarily unique)
   * @param logger - Optional logger instance
   */
  function Workflow(name, logger) {
    /**
     * Detects unreachable steps in the workflow
     * @returns Array of ValidationError objects
     */
    Object.defineProperty(this, _detectUnreachableSteps, {
      value: _detectUnreachableSteps2
    });
    /**
     * Validates the workflow for terminal paths
     * @returns Array of ValidationError objects
     */
    Object.defineProperty(this, _validateTerminalPaths, {
      value: _validateTerminalPaths2
    });
    /**
     * Detects circular dependencies in the workflow
     * @returns Array of ValidationError objects
     */
    Object.defineProperty(this, _detectCircularDependencies, {
      value: _detectCircularDependencies2
    });
    /**
     * Validates the workflow for circular dependencies, terminal paths, and unreachable steps
     * @throws Error if validation fails
     */
    Object.defineProperty(this, _validateWorkflow, {
      value: _validateWorkflow2
    });
    /**
     * Evaluates a single condition against workflow context
     */
    Object.defineProperty(this, _evaluateCondition, {
      value: _evaluateCondition2
    });
    /**
     * Cleans up the actor instance
     */
    Object.defineProperty(this, _cleanup, {
      value: _cleanup2
    });
    /**
     * Resolves variables for a step from trigger data or previous step results
     * @param stepConfig - Configuration of the step needing variable resolution
     * @param context - Current workflow context containing results and trigger data
     * @returns Object containing resolved variable values
     * @throws Error if variable resolution fails
     */
    Object.defineProperty(this, _resolveVariables, {
      value: _resolveVariables2
    });
    /**
     * Creates a validated step ID, ensuring uniqueness within the workflow
     * @param id - Proposed step ID
     * @returns The validated and branded step ID
     * @throws Error if ID is invalid or duplicate
     */
    Object.defineProperty(this, _createStepId, {
      value: _createStepId2
    });
    /**
     * Type guard to check if a value is a valid VariableReference
     * @param value - Value to check
     * @returns True if value is a VariableReference
     */
    Object.defineProperty(this, _isVariableReference, {
      value: _isVariableReference2
    });
    /**
     * Builds the state hierarchy for the workflow
     * @returns Object representing the state hierarchy
     */
    Object.defineProperty(this, _buildStateHierarchy, {
      value: _buildStateHierarchy2
    });
    /**
     * Internal logging helper that formats and sends logs to the configured logger
     * @param level - Severity level of the log
     * @param message - Main log message
     * @param data - Optional data to include in the log
     * @param stepId - Optional ID of the step that generated the log
     */
    Object.defineProperty(this, _log, {
      value: _log2
    });
    this.name = void 0;
    Object.defineProperty(this, _logger, {
      writable: true,
      value: void 0
    });
    this.triggerSchema = void 0;
    Object.defineProperty(this, _steps, {
      writable: true,
      value: []
    });
    /** XState machine instance that orchestrates the workflow execution */
    Object.defineProperty(this, _machine, {
      writable: true,
      value: void 0
    });
    /** XState actor instance that manages the workflow execution */
    Object.defineProperty(this, _actor, {
      writable: true,
      value: null
    });
    this.name = name;
    _classPrivateFieldLooseBase(this, _logger)[_logger] = logger;
    this.initializeMachine();
  }
  var _proto = Workflow.prototype;
  /**
   * Initializes the XState machine for the workflow
   *
   * Registers the machine's types, actions, actors, initial context, entry actions, initial state, and states
   * @returns The initialized machine
   */
  _proto.initializeMachine = function initializeMachine() {
    var _this = this,
      _classPrivateFieldLoo;
    var machine = setup({
      types: {},
      actions: {
        updateStepResult: assign({
          stepResults: function stepResults(_ref) {
            var _event$output, _event$output2;
            var context = _ref.context,
              event = _ref.event;
            if (!isTransitionEvent(event)) return context.stepResults;
            var stepId = (_event$output = event.output) == null ? void 0 : _event$output.stepId;
            if (!stepId) return context.stepResults;
            _classPrivateFieldLooseBase(_this, _log)[_log](LogLevel.INFO, "Step " + stepId + " completed", event.output, stepId);
            var result = (_event$output2 = event.output) == null ? void 0 : _event$output2.result;
            if (result !== undefined) {
              var _extends2;
              var newResults = _extends({}, context.stepResults, (_extends2 = {}, _extends2[stepId] = result, _extends2));
              // Get the step configuration
              var step = _classPrivateFieldLooseBase(_this, _steps)[_steps].find(function (s) {
                return s.id === stepId;
              });
              // Evaluate transitions and send events
              if (step != null && step.transitions) {
                var fullContext = _extends({}, context, {
                  stepResults: newResults
                });
                var hasMatchingCondition = false;
                _classPrivateFieldLooseBase(_this, _log)[_log](LogLevel.DEBUG, 'Evaluating transitions with context:', fullContext);
                Object.entries(step.transitions).forEach(function (_ref2) {
                  var targetId = _ref2[0],
                    config = _ref2[1];
                  _classPrivateFieldLooseBase(_this, _log)[_log](LogLevel.DEBUG, "Checking transition to: " + targetId);
                  _classPrivateFieldLooseBase(_this, _log)[_log](LogLevel.DEBUG, "With condition: " + config.condition);
                  if (!config.condition || _classPrivateFieldLooseBase(_this, _evaluateCondition)[_evaluateCondition](config.condition, fullContext)) {
                    hasMatchingCondition = true;
                    _classPrivateFieldLooseBase(_this, _log)[_log](LogLevel.DEBUG, 'Condition passed, sending transition to:', targetId);
                    Promise.resolve().then(function () {
                      if (_classPrivateFieldLooseBase(_this, _actor)[_actor]) {
                        _classPrivateFieldLooseBase(_this, _actor)[_actor].send({
                          type: "TRANSITION_" + targetId
                        });
                      }
                    });
                  }
                });
                // If no conditions matched, send the NO_MATCHING_CONDITIONS event
                if (!hasMatchingCondition) {
                  Promise.resolve().then(function () {
                    if (_classPrivateFieldLooseBase(_this, _actor)[_actor]) {
                      _classPrivateFieldLooseBase(_this, _actor)[_actor].send({
                        type: 'NO_MATCHING_CONDITIONS'
                      });
                    }
                  });
                }
              }
              return newResults;
            }
            return context.stepResults;
          }
        }),
        setError: assign({
          error: function error(_ref3) {
            var event = _ref3.event;
            if (!isErrorEvent(event)) return null;
            _classPrivateFieldLooseBase(_this, _log)[_log](LogLevel.ERROR, "Workflow error", event.error);
            return event.error;
          }
        }),
        initializeTriggerData: assign({
          triggerData: function triggerData(_ref4) {
            var context = _ref4.context;
            _classPrivateFieldLooseBase(_this, _log)[_log](LogLevel.INFO, 'Workflow started', context == null ? void 0 : context.triggerData);
            return context == null ? void 0 : context.triggerData;
          }
        })
      },
      actors: {
        resolverFunction: fromPromise(/*#__PURE__*/function () {
          var _ref6 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref5) {
            var input, step, context, resolvedData, result;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  input = _ref5.input;
                  step = input.step, context = input.context;
                  resolvedData = _classPrivateFieldLooseBase(_this, _resolveVariables)[_resolveVariables](step, context);
                  _context.next = 5;
                  return step.handler(resolvedData);
                case 5:
                  result = _context.sent;
                  return _context.abrupt("return", {
                    stepId: step.id,
                    result: result
                  });
                case 7:
                case "end":
                  return _context.stop();
              }
            }, _callee);
          }));
          return function (_x) {
            return _ref6.apply(this, arguments);
          };
        }())
      }
    }).createMachine({
      id: this.name,
      initial: ((_classPrivateFieldLoo = _classPrivateFieldLooseBase(this, _steps)[_steps][0]) == null ? void 0 : _classPrivateFieldLoo.id) || 'idle',
      context: function context(_ref7) {
        var input = _ref7.input;
        return _extends({}, input, {
          stepResults: {},
          error: null
        });
      },
      entry: ['initializeTriggerData'],
      states: _classPrivateFieldLooseBase(this, _buildStateHierarchy)[_buildStateHierarchy]()
    });
    _classPrivateFieldLooseBase(this, _machine)[_machine] = machine;
    return machine;
  }
  /**
   * Rebuilds the machine with the current steps configuration and validates the workflow
   *
   * This is the last step of a workflow builder method chain
   * @throws Error if validation fails
   */;
  _proto.commit = function commit() {
    _classPrivateFieldLooseBase(this, _validateWorkflow)[_validateWorkflow]();
    this.initializeMachine();
  };
  /**
   * Sets the schema for validating trigger data
   * @param schema - Zod schema for trigger data validation
   * @returns this instance for method chaining
   */
  _proto.setTriggerSchema = function setTriggerSchema(schema) {
    this.triggerSchema = schema;
    return this;
  };
  /**
   * Adds a new step to the workflow
   * @param id - Unique identifier for the step
   * @param config - Step configuration including handler, schema, variables, and payload
   * @returns this instance for method chaining (builder pattern baybyyyy)
   * @throws Error if step ID is duplicate or variable resolution fails
   */
  _proto.addStep = function addStep(id, config) {
    var _this2 = this;
    var stepId = _classPrivateFieldLooseBase(this, _createStepId)[_createStepId](id);
    var action = config.action,
      inputSchema = config.inputSchema,
      _config$variables = config.variables,
      variables = _config$variables === void 0 ? {} : _config$variables,
      _config$payload = config.payload,
      payload = _config$payload === void 0 ? {} : _config$payload,
      transitions = config.transitions;
    // Validate transitions reference existing steps
    if (transitions) {
      Object.keys(transitions).forEach(function (targetId) {
        // Skip validation for steps that will be added later
        if (!_classPrivateFieldLooseBase(_this2, _steps)[_steps].some(function (s) {
          return s.id === targetId;
        })) {
          _classPrivateFieldLooseBase(_this2, _log)[_log](LogLevel.DEBUG, "Step " + targetId + " not found yet, will be validated when workflow starts");
        }
      });
    }
    var requiredData = {};
    // Add valid variables to requiredData
    for (var _i = 0, _Object$entries = Object.entries(variables); _i < _Object$entries.length; _i++) {
      var _Object$entries$_i = _Object$entries[_i],
        key = _Object$entries$_i[0],
        variable = _Object$entries$_i[1];
      if (variable && _classPrivateFieldLooseBase(this, _isVariableReference)[_isVariableReference](variable)) {
        requiredData[key] = variable;
      }
    }
    // Create step config
    var stepConfig = {
      id: stepId,
      handler: function () {
        var _handler = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(data) {
          var mergedData, validatedData;
          return _regeneratorRuntime().wrap(function _callee2$(_context2) {
            while (1) switch (_context2.prev = _context2.next) {
              case 0:
                // Merge static payload with dynamically resolved variables
                // Variables take precedence over payload values
                mergedData = _extends({}, payload, data); // Validate complete input data
                validatedData = inputSchema ? inputSchema.parse(mergedData) : mergedData;
                return _context2.abrupt("return", action(validatedData));
              case 3:
              case "end":
                return _context2.stop();
            }
          }, _callee2);
        }));
        function handler(_x2) {
          return _handler.apply(this, arguments);
        }
        return handler;
      }(),
      inputSchema: inputSchema,
      requiredData: requiredData,
      transitions: transitions
    };
    _classPrivateFieldLooseBase(this, _steps)[_steps].push(stepConfig);
    return this;
  };
  /**
   * Executes the workflow with the given trigger data
   * @param triggerData - Initial data to start the workflow with
   * @returns Promise resolving to workflow results or rejecting with error
   * @throws Error if trigger schema validation fails
   */
  _proto.executeWorkflow =
  /*#__PURE__*/
  function () {
    var _executeWorkflow = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3(triggerData) {
      var _this3 = this;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _classPrivateFieldLooseBase(this, _log)[_log](LogLevel.INFO, 'Executing workflow', {
              triggerData: triggerData
            });
          case 2:
            if (!this.triggerSchema) {
              _context3.next = 14;
              break;
            }
            _context3.prev = 3;
            this.triggerSchema.parse(triggerData);
            _context3.next = 7;
            return _classPrivateFieldLooseBase(this, _log)[_log](LogLevel.DEBUG, 'Trigger schema validation passed');
          case 7:
            _context3.next = 14;
            break;
          case 9:
            _context3.prev = 9;
            _context3.t0 = _context3["catch"](3);
            _context3.next = 13;
            return _classPrivateFieldLooseBase(this, _log)[_log](LogLevel.ERROR, 'Trigger schema validation failed', {
              error: _context3.t0
            });
          case 13:
            throw _context3.t0;
          case 14:
            _classPrivateFieldLooseBase(this, _actor)[_actor] = createActor(_classPrivateFieldLooseBase(this, _machine)[_machine], {
              input: {
                error: null,
                stepResults: {},
                triggerData: triggerData || {}
              }
            });
            _classPrivateFieldLooseBase(this, _actor)[_actor].start();
            return _context3.abrupt("return", new Promise(function (resolve, reject) {
              if (!_classPrivateFieldLooseBase(_this3, _actor)[_actor]) {
                reject(new Error('Actor not initialized'));
                return;
              }
              _classPrivateFieldLooseBase(_this3, _actor)[_actor].subscribe(function (state) {
                if (state.matches('success')) {
                  _classPrivateFieldLooseBase(_this3, _log)[_log](LogLevel.INFO, 'Workflow completed successfully', {
                    results: state.context.stepResults
                  });
                  _classPrivateFieldLooseBase(_this3, _cleanup)[_cleanup]();
                  resolve({
                    triggerData: triggerData,
                    results: state.context.stepResults
                  });
                } else if (state.matches('failure')) {
                  var _state$context$error, _state$context$error2;
                  _classPrivateFieldLooseBase(_this3, _log)[_log](LogLevel.ERROR, 'Workflow failed', {
                    error: (_state$context$error = state.context.error) == null ? void 0 : _state$context$error.message
                  });
                  _classPrivateFieldLooseBase(_this3, _cleanup)[_cleanup]();
                  reject({
                    error: (_state$context$error2 = state.context.error) == null ? void 0 : _state$context$error2.message
                  });
                }
              });
            }));
          case 17:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this, [[3, 9]]);
    }));
    function executeWorkflow(_x3) {
      return _executeWorkflow.apply(this, arguments);
    }
    return executeWorkflow;
  }();
  return Workflow;
}();
function _log2(_x4, _x5, _x6, _x7) {
  return _log3.apply(this, arguments);
}
function _log3() {
  _log3 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee4(level, message, data, stepId) {
    var _classPrivateFieldLoo2, _classPrivateFieldLoo3;
    var logMessage, logMethod;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          if (_classPrivateFieldLooseBase(this, _logger)[_logger]) {
            _context4.next = 2;
            break;
          }
          return _context4.abrupt("return");
        case 2:
          logMessage = {
            type: RegisteredLogger.WORKFLOW,
            message: message,
            workflowName: this.name,
            destinationPath: "workflows/" + this.name,
            stepId: stepId,
            data: data
          };
          logMethod = level.toLowerCase();
          _context4.next = 6;
          return (_classPrivateFieldLoo2 = (_classPrivateFieldLoo3 = _classPrivateFieldLooseBase(this, _logger)[_logger])[logMethod]) == null ? void 0 : _classPrivateFieldLoo2.call(_classPrivateFieldLoo3, logMessage);
        case 6:
        case "end":
          return _context4.stop();
      }
    }, _callee4, this);
  }));
  return _log3.apply(this, arguments);
}
function _buildStateHierarchy2() {
  var _this4 = this;
  var stateHierarchy = {
    idle: {},
    success: {
      type: 'final'
    },
    failure: {
      type: 'final'
    }
  };
  // Helper to build nested state structure
  var buildState = function buildState(currentStepId, visited) {
    if (visited.has(currentStepId)) return null;
    visited.add(currentStepId);
    var currentStep = _classPrivateFieldLooseBase(_this4, _steps)[_steps].find(function (s) {
      return s.id === currentStepId;
    });
    if (!currentStep) return null;
    var state = {
      invoke: {
        src: 'resolverFunction',
        input: function input(_ref8) {
          var context = _ref8.context;
          return {
            step: currentStep,
            context: context
          };
        },
        onDone: {
          actions: ['updateStepResult'],
          // If no transitions, go to success state
          target: currentStep.transitions ? undefined : 'success'
        },
        onError: {
          target: 'failure',
          actions: ['setError']
        }
      },
      on: {
        // Default transition will trigger if no conditions match
        NO_MATCHING_CONDITIONS: {
          target: 'failure',
          actions: assign({
            error: function error() {
              console.log('No matching transition conditions');
              return new Error('No matching transition conditions');
            }
          })
        }
      }
    };
    // Handle transitions
    if (currentStep.transitions) {
      Object.entries(currentStep.transitions).forEach(function (_ref9) {
        var targetId = _ref9[0],
          config = _ref9[1];
        // Create flat state structure with transitions
        state.on["TRANSITION_" + targetId] = {
          target: targetId,
          guard: function guard(_ref10) {
            var context = _ref10.context;
            return !config.condition || _classPrivateFieldLooseBase(_this4, _evaluateCondition)[_evaluateCondition](config.condition, context);
          }
        };
      });
    }
    return state;
  };
  // Build flat state structure starting from first step
  var visited = new Set();
  _classPrivateFieldLooseBase(this, _steps)[_steps].forEach(function (step) {
    var state = buildState(step.id, visited);
    if (state) {
      stateHierarchy[step.id] = state;
    }
  });
  return stateHierarchy;
}
function _isVariableReference2(value) {
  return typeof value === 'object' && 'stepId' in value && 'path' in value;
}
function _createStepId2(id) {
  // Check for duplicates
  if (_classPrivateFieldLooseBase(this, _steps)[_steps].some(function (step) {
    return step.id === id;
  })) {
    throw new Error("Step with ID \"" + id + "\" already exists in workflow \"" + this.name + "\"");
  }
  return id;
}
function _resolveVariables2(stepConfig, context) {
  var resolvedData = {};
  for (var _i2 = 0, _Object$entries2 = Object.entries(stepConfig.requiredData); _i2 < _Object$entries2.length; _i2++) {
    var _Object$entries2$_i = _Object$entries2[_i2],
      key = _Object$entries2$_i[0],
      variable = _Object$entries2$_i[1];
    // Check if variable comes from trigger data or a previous step's result
    var sourceData = variable.stepId === 'trigger' ? context.triggerData : context.stepResults[variable.stepId];
    if (!sourceData && variable.stepId !== 'trigger') {
      throw new Error("Cannot resolve variable: Step " + variable.stepId + " has not been executed yet");
    }
    // If path is empty or '.', return the entire source data
    var value = variable.path === '' || variable.path === '.' ? sourceData[key] : get(sourceData, variable.path);
    if (value === undefined) {
      throw new Error("Cannot resolve path \"" + variable.path + "\" from " + variable.stepId);
    }
    resolvedData[key] = value;
  }
  return resolvedData;
}
function _cleanup2() {
  if (_classPrivateFieldLooseBase(this, _actor)[_actor]) {
    _classPrivateFieldLooseBase(this, _actor)[_actor].stop();
    _classPrivateFieldLooseBase(this, _actor)[_actor] = null;
  }
}
function _evaluateCondition2(condition, context) {
  var _this5 = this;
  var andBranchResult = true;
  var baseResult = true;
  var orBranchResult = true;
  // Base condition
  if ('ref' in condition) {
    var ref = condition.ref,
      query = condition.query;
    var sourceData = ref.stepId === 'trigger' ? context.triggerData : context.stepResults[ref.stepId];
    if (!sourceData) {
      throw new Error("Cannot evaluate condition: Step " + ref.stepId + " has not been executed yet");
    }
    var value = get(sourceData, ref.path);
    baseResult = sift(query)(value);
  }
  // AND condition
  if ('and' in condition) {
    andBranchResult = condition.and.every(function (cond) {
      return _classPrivateFieldLooseBase(_this5, _evaluateCondition)[_evaluateCondition](cond, context);
    });
  }
  // OR condition
  if ('or' in condition) {
    orBranchResult = condition.or.some(function (cond) {
      return _classPrivateFieldLooseBase(_this5, _evaluateCondition)[_evaluateCondition](cond, context);
    });
  }
  var finalResult = baseResult && andBranchResult && orBranchResult;
  return finalResult;
}
function _validateWorkflow2() {
  var errors = [].concat(_classPrivateFieldLooseBase(this, _detectCircularDependencies)[_detectCircularDependencies](), _classPrivateFieldLooseBase(this, _validateTerminalPaths)[_validateTerminalPaths](), _classPrivateFieldLooseBase(this, _detectUnreachableSteps)[_detectUnreachableSteps]());
  if (errors.length > 0) {
    var errorMessages = errors.map(function (error) {
      return "[" + error.type + "] " + error.message + (error.details.path ? " (Path: " + error.details.path.join(' → ') + ")" : '') + (error.details.stepId ? " (Step: " + error.details.stepId + ")" : '');
    });
    throw new Error("Workflow validation failed:\n" + errorMessages.join('\n'));
  }
}
function _detectCircularDependencies2() {
  var _this6 = this;
  var errors = [];
  var stack = [];
  var _dfs = function dfs(stepId) {
    if (stack.includes(stepId)) {
      // Found a cycle
      var cycleStartIndex = stack.indexOf(stepId);
      var cyclePath = [].concat(stack.slice(cycleStartIndex), [stepId]);
      errors.push({
        type: 'circular_dependency',
        message: 'Circular dependency detected in workflow',
        details: {
          path: cyclePath
        }
      });
      return;
    }
    stack.push(stepId);
    var step = _classPrivateFieldLooseBase(_this6, _steps)[_steps].find(function (s) {
      return s.id === stepId;
    });
    if (step != null && step.transitions) {
      Object.keys(step.transitions).forEach(function (targetId) {
        _dfs(targetId);
      });
    }
    stack.pop();
  };
  // Start DFS from first step
  if (_classPrivateFieldLooseBase(this, _steps)[_steps].length > 0) {
    _dfs(_classPrivateFieldLooseBase(this, _steps)[_steps][0].id);
  }
  return errors;
}
function _validateTerminalPaths2() {
  var _this7 = this;
  var errors = [];
  var visited = new Set();
  var hasTerminalPath = new Set();
  var _dfs2 = function dfs(stepId, path) {
    if (path === void 0) {
      path = [];
    }
    if (hasTerminalPath.has(stepId)) return true;
    if (visited.has(stepId) && !hasTerminalPath.has(stepId)) return false;
    visited.add(stepId);
    var step = _classPrivateFieldLooseBase(_this7, _steps)[_steps].find(function (s) {
      return s.id === stepId;
    });
    if (!step) return false;
    // Terminal step
    if (!step.transitions) {
      hasTerminalPath.add(stepId);
      return true;
    }
    var transitions = Object.keys(step.transitions);
    if (transitions.length === 0) {
      hasTerminalPath.add(stepId);
      return true;
    }
    // Check if any transition leads to a terminal state
    var leadsToTerminal = transitions.some(function (targetId) {
      return !path.includes(targetId) && _dfs2(targetId, [].concat(path, [stepId]));
    });
    if (leadsToTerminal) {
      hasTerminalPath.add(stepId);
    } else {
      errors.push({
        type: 'no_terminal_path',
        message: 'No path to terminal state found',
        details: {
          stepId: stepId,
          path: [].concat(path, [stepId])
        }
      });
    }
    return leadsToTerminal;
  };
  // Start from first step
  if (_classPrivateFieldLooseBase(this, _steps)[_steps].length > 0) {
    _dfs2(_classPrivateFieldLooseBase(this, _steps)[_steps][0].id);
  }
  return errors;
}
function _detectUnreachableSteps2() {
  var _this8 = this;
  var errors = [];
  var reachableSteps = new Set();
  var _dfs3 = function dfs(stepId) {
    if (reachableSteps.has(stepId)) return;
    reachableSteps.add(stepId);
    var step = _classPrivateFieldLooseBase(_this8, _steps)[_steps].find(function (s) {
      return s.id === stepId;
    });
    if (step != null && step.transitions) {
      Object.keys(step.transitions).forEach(function (targetId) {
        _dfs3(targetId);
      });
    }
  };
  // Start from first step
  if (_classPrivateFieldLooseBase(this, _steps)[_steps].length > 0) {
    _dfs3(_classPrivateFieldLooseBase(this, _steps)[_steps][0].id);
  }
  // Find unreachable steps
  _classPrivateFieldLooseBase(this, _steps)[_steps].forEach(function (step) {
    if (!reachableSteps.has(step.id)) {
      errors.push({
        type: 'unreachable_step',
        message: 'Step is not reachable from the initial step',
        details: {
          stepId: step.id
        }
      });
    }
  });
  return errors;
}

export { Agent, BaseLogger, FieldTypePrimitiveMap, FilterOperators, Integration, LogLevel, Mastra, MastraEngine, MastraVector, MultiLogger, PropertyType, RegisteredLogger, Workflow, buildQueryString, createLogger, createMultiLogger, createTool, filterQuerySchema, getJSONField, sortQuerySchema, splitAndStripQuotes, transformFilterValueArray, transformFilterValueBoolean };
//# sourceMappingURL=core.esm.js.map
